 package com.example.canvastest;

import android.app.Activity;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ComposePathEffect;
import android.graphics.CornerPathEffect;
import android.graphics.DashPathEffect;
import android.graphics.DiscretePathEffect;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.PathDashPathEffect;
import android.graphics.PathEffect;
import android.graphics.RadialGradient;
import android.graphics.RectF;
import android.graphics.Shader;
import android.graphics.SumPathEffect;
import android.os.Bundle;
import android.view.View;

public class MainActivity extends Activity {
	
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(new MyView(this));        
    }
    class MyView extends View
    {
    	float phase1=0;
    	float phase2=0;
    	Path path;
		public MyView(Context context) {
			super(context);
			path=new Path();
			path.moveTo(0, 0);
			for (int i = 1; i <= 10; i++)
			{
				//15㣬ǵYꡣһPath
				path.lineTo(i * 30, (float) Math.random() * 20);
			}
		}
		protected void onDraw(Canvas canvas) {
			super.onDraw(canvas);
			//ûΪɫ
			canvas.drawColor(Color.WHITE);
			//ûʽ
			Paint paint=new Paint();
			//
			paint.setAntiAlias(true);
			paint.setColor(Color.BLUE);
			paint.setStyle(Paint.Style.STROKE);
			paint.setStrokeWidth(2.5f);
			//Բ
			canvas.drawCircle(35, 35, 25, paint);
			//Բ
			RectF r1=new RectF(10, 70, 60, 100);
			canvas.drawOval(r1, paint);
			//ƾ
			canvas.drawRect(10,110,60,140,paint);
			//ԲǾ
			RectF r2=new RectF(10, 150, 60, 180);
			canvas.drawRoundRect(r2, 15, 15, paint);
			//·Ϊεͼ
			Path path1=new Path();
			path1.moveTo(10, 230);
			path1.lineTo(60, 230);
			path1.lineTo(35, 190);
			path1.close();
			canvas.drawPath(path1, paint);
			//ûʽ
			paint.setColor(Color.YELLOW);
			paint.setStyle(Paint.Style.FILL);
			//»ͼεһʽ
			canvas.drawCircle(95, 35, 25, paint);
			RectF r3=new RectF(70, 70, 120, 100);
			canvas.drawOval(r3, paint);
			canvas.drawRect(70,110,120,140,paint);
			RectF r4=new RectF(70, 150, 120, 180);
			canvas.drawRoundRect(r4, 15, 15, paint);
			Path path2=new Path();
			path2.moveTo(70, 230);
			path2.lineTo(120, 230);
			path2.lineTo(95, 190);
			path2.close();//պ·
			canvas.drawPath(path2, paint);
			//ȾЧ
			Shader myShader=new RadialGradient(0, 0, 25, 
					new int[]{Color.GREEN,Color.RED},
					null,Shader.TileMode.REPEAT);
			paint.setShader(myShader);
			paint.setShadowLayer(15, 5, 5, Color.BLACK);
			//ٴλͼ
			canvas.drawCircle(155, 35, 25, paint);
			RectF r5=new RectF(130, 70, 180, 100);
			canvas.drawOval(r5, paint);
			canvas.drawRect(130,110,180,140,paint);
			RectF r6=new RectF(130, 150, 180, 180);
			canvas.drawRoundRect(r6, 15, 15, paint);
			Path path3=new Path();
			path3.moveTo(130, 230);
			path3.lineTo(180, 230);
			path3.lineTo(155, 190);
			path3.close();
			canvas.drawPath(path3, paint);
			//ȡȾЧ
			paint.setShader(null);
			//ȡӰ
			paint.setShadowLayer(0, 0, 0, 0);
			//ִС
			paint.setTextSize(20);		
			//ɫ
			paint.setColor(Color.BLACK);			
			//ַ
			canvas.drawText(getResources().getString(R.string.circle), 225, 45, paint);
			canvas.drawText(getResources().getString(R.string.oval), 215, 90, paint);
			canvas.drawText(getResources().getString(R.string.rect), 215, 135, paint);
			canvas.drawText(getResources().getString(R.string.round_rect), 195, 170, paint);
			canvas.drawText(getResources().getString(R.string.triangle), 210, 220, paint);
			//ʹPathEffect
			paint.setStyle(Paint.Style.STROKE);
			PathEffect[] pathEffects=new PathEffect[8];
			//PathEffect
			pathEffects[0]=null;
			//CornerPathEffectЧ
			pathEffects[1]=new CornerPathEffect(5);
			//DashPathEffectЧ
			pathEffects[2]=new DashPathEffect(new float[]{2,8,15,2}, phase1);
			//DiscretePathEffectЧ
			pathEffects[3]=new DiscretePathEffect(1.5f,5);
			//PathDashPathEffectЧ
			Path path5=new Path();
			path5.addRect(0 , 0, 5, 5, Path.Direction.CCW);
			pathEffects[4]=new PathDashPathEffect(path5, 2.0f, phase1, PathDashPathEffect.Style.ROTATE);
			//SumPathEffectЧ
			pathEffects[5]=new SumPathEffect(pathEffects[3], pathEffects[4]);
			//ComposePathEffectЧ
			pathEffects[6]=new ComposePathEffect(pathEffects[2], pathEffects[3]);
			//ԱComposePathEffectSumPathEffect
			pathEffects[7]=new SumPathEffect(pathEffects[2], pathEffects[3]);
			//ƶ
			canvas.translate(0, 50);
			for (int i = 0; i <=3; i++){
				paint.setPathEffect(pathEffects[i]);
				canvas.drawPath(path1, paint);
				canvas.translate(60, 0);
			}
			canvas.translate(-240, 55);
			for (int i = 4; i <=7; i++){
				paint.setPathEffect(pathEffects[i]);
				canvas.drawPath(path1, paint);
				canvas.translate(60, 0);
			}
			canvas.translate(-230, 250);
			PathEffect pathEffect=new DashPathEffect(new float[]{15,10,5,10}, phase2);
			paint.setPathEffect(pathEffect);
			canvas.drawPath(path, paint);
			phase2+=1;
			//ػ
			invalidate();
		} 
	}
}