package com.example.bitmap_animationtest;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.AnimationDrawable;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ImageView;
import android.widget.ToggleButton;

public class MainActivity extends Activity {

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        final ImageView bitmap1=(ImageView)findViewById(R.id.bitmap1);
        final ImageView bitmap2=(ImageView)findViewById(R.id.bitmap2);
       	bitmap1.setImageBitmap(BitmapFactory.decodeResource(getResources(), R.drawable.grass));
		bitmap1.setOnTouchListener(new OnTouchListener() {
			public boolean onTouch(View v, MotionEvent event) {
				//BitmapDrawable bitmapDrawable=(BitmapDrawable)bitmap1.getDrawable();
				Bitmap bitmap=BitmapFactory.decodeResource(getResources(), R.drawable.grass);
				//ȡԭͼ
				float xchange=bitmap.getWidth()/(float)bitmap1.getWidth();
				float ychange=bitmap.getHeight()/(float)bitmap1.getHeight();
				//λöӦԭͼ
				int x=(int)(event.getX()*xchange);
				int y=(int)(event.getY()*ychange);
				//Խж
				if(x+50>bitmap.getWidth()){
					x=bitmap.getWidth()-50;
				}
				if(x-50<0){
					x=50;
				}
				if(y+50>bitmap.getHeight()){
					y=bitmap.getHeight()-50;
				}
				if(y-50<0){
					y=50;
				}
				//ԵλΪģ鿴ԭͼľֲϸ
				bitmap2.setImageBitmap(Bitmap.createBitmap(bitmap, x-50, y-50, 100, 100));
				bitmap2.setVisibility(View.VISIBLE);
				return false;
			}
		});
		final Button start=(Button)findViewById(R.id.start);
		final Button stop=(Button)findViewById(R.id.stop);
		final ImageView animImg=(ImageView)findViewById(R.id.animImg);
		final AnimationDrawable anim=(AnimationDrawable)animImg.getDrawable();
		start.setOnClickListener(new OnClickListener() {
    		public void onClick(View v) {
    			anim.start();
    		}
    	});
        stop.setOnClickListener(new OnClickListener() {
    		public void onClick(View v) {
    			anim.stop();
    		}
    	});
        //ʼʱʾͼĽ棬֡Ľ治ʾ
        bitmap1.setVisibility(View.VISIBLE);
		bitmap2.setVisibility(View.INVISIBLE);
		start.setVisibility(View.GONE);
		stop.setVisibility(View.GONE);
		animImg.setVisibility(View.GONE);
		ToggleButton tb=(ToggleButton)findViewById(R.id.change);
        tb.setOnCheckedChangeListener(new OnCheckedChangeListener() {
        	public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        		if(isChecked){
        			//ʾͼƬĽ
					bitmap1.setVisibility(View.VISIBLE);
					bitmap2.setVisibility(View.INVISIBLE);
					//֡Ľ治ʾ
					start.setVisibility(View.GONE);
					stop.setVisibility(View.GONE);
					animImg.setVisibility(View.GONE);	
				}
				else{
					//ͼƬĽ治ʾ
					bitmap1.setVisibility(View.GONE);
					bitmap2.setVisibility(View.GONE);
					//ʾ֡Ľ
					start.setVisibility(View.VISIBLE);
					stop.setVisibility(View.VISIBLE);
					animImg.setVisibility(View.VISIBLE);
					//ֹͣ֡
					anim.stop();
				}	
        	}
		}); 
    } 
}
